
local ProfList = {
	
	["poor"] = WEAPON_PROFICIENCY_POOR,
	["average"] = WEAPON_PROFICIENCY_AVERAGE,
	["good"] = WEAPON_PROFICIENCY_GOOD,
	["very_good"] = WEAPON_PROFICIENCY_VERY_GOOD,
	["perfect"] = WEAPON_PROFICIENCY_PERFECT
	
}

local NPCList = {
	
	["alyx"] = {
		class ="npc_alyx",
		proficiency = ProfList["average"]
	},
	["barney"] = {
		class = "npc_barney",
		proficiency = ProfList["average"]
	},
	["rebel"] = {
		class = "npc_citizen_rebel",
		proficiency = ProfList["average"]
	},
	["medic"] = {
		class = "npc_citizen_medic",
		proficiency = ProfList["average"]
	},
	["citizen"] = {
		class = "npc_citizen",
		proficiency = ProfList["average"]
	},
	["combine_super"] = {
		class = "npc_combine_e",
		proficiency = ProfList["average"]
	},
	["combine_soldier"] = {
		class = "npc_combine_s",
		proficiency = ProfList["average"]
	},
	["combine_prision"] = {
		class = "npc_combine_p",
		proficiency = ProfList["average"]
	},
	["metro_police"] = {
		class = "npc_metropolice",
		proficiency = ProfList["average"]
	},
	["father_grigori"] = {
		class = "npc_monk",
		proficiency = ProfList["average"]
	}
	
}

if SERVER then
	
	concommand.Add("npc_prof", function(ply, cmd, args)
		
		/*=====================================
		Console command for setting proficency.
		=====================================*/
		
		if not ply:IsAdmin() then
			print("You must be an admin to change NPC Proficiency.")
			return
		end
		
		local InName = args[1] or "[blank]"
		local InProf = args[2] or "[blank]"
		
		InName = string.lower(InName)
		InProf = string.lower(InProf)
		
		if (NPCList[InName] == nil) and not(InName == "all") then 
			
			print(InName.." is not a supported NPC.")
			return
			
		end
		
		if ProfList[InProf] == nil then
			
			print(InProf.." is not a supported proficiency.")
			return
			
		end
		
		if (InName == "all") then
			
			for k,v in pairs(NPCList) do
				
				NPCList[k].proficiency = ProfList[InProf]
				
			end
			
		else
			
			NPCList[InName].proficiency = ProfList[InProf]
			
		end
		
		print(InName.."'s proficiency is now "..InProf)
		
	end, function(cmd, args)
		
		/*=============================================
		Auto-complete function for the console command.
			Todo:  Make this actually return something.
		=============================================*/
		
	end)
	
	hook.Add("Think", "NPC Proficiency", function()
		
		/*============================================
		Think hook to set the proficiency of all npcs.
		============================================*/
		
		for k,v in pairs(NPCList) do
			
			for _,npc in pairs(ents.FindByClass(NPCList[k].class)) do
				
				npc:SetCurrentWeaponProficiency(NPCList[k].proficiency)
				
			end
			
		end
		
	end)
	
end

if CLIENT then
	
	local Items = {npc = "NONE", prof = "NONE"}
	
	concommand.Add("npc_prof_menu", function(ply, cmd, args)
		
		/*=======================================
		Spawn the Derma menu to edit proficiency.
		=======================================*/
		
		if not ply:IsAdmin() then
			print("You must be an admin to change NPC Proficiency.")
			return
		end
		
		local frame = vgui.Create("DFrame")
		frame:SetSize(412, 360)
		frame:SetTitle("NPC Proficency menu")
		frame:Center()
		frame:SetDraggable( true )
		frame:MakePopup()
		
		local npcList = vgui.Create("DComboBox", frame)
		npcList:SetSize(200, 274)
		npcList:SetPos(4, 26)
		for k,v in pairs(NPCList) do
			npcList:AddItem(k)
		end
		npcList:AddItem("all")
		
		local profList = vgui.Create("DComboBox", frame)
		profList:SetSize(200, 274)
		profList:SetPos(208 ,26)
		for k,v in pairs(ProfList) do
			profList:AddItem(k)
		end
		
		frame.Think = function()
			
			if npcList:GetSelectedItems() and npcList:GetSelectedItems()[1] then
				Items.npc = npcList:GetSelectedItems()[1]:GetValue() or "NONE"
			end
			
			if profList:GetSelectedItems() and profList:GetSelectedItems()[1] then
				Items.prof = profList:GetSelectedItems()[1]:GetValue() or "NONE"
			end
			
		end
		
		frame.PaintOver = function()
			
			local text = "Change "..Items.npc.."'s proficiency to "..Items.prof.."?"
			local font = "MenuItem"
			
			draw.DrawText(text,font,206,316,Color(255,255,255),TEXT_ALIGN_CENTER)
			
		end
		
		local button = vgui.Create("DButton", frame)
		button:SetSize(60, 22)
		button:SetPos(176, 334)
		button:SetText("Confirm")
		button.DoClick = function()
			RunConsoleCommand("npc_prof", Items.npc, Items.prof)
		end
		
	end)
	
end